      program import
      CHARACTER*(255) NAME1,NAME2
      write (*,*) 'Please enter the name of the source file'
      read (*,*) name1
      write (*,*) 'Please enter the name of the target file'
      read (*,*) name2
      call eximp2(10,name1,11,name2)
      end

      subroutine eximp2(iu,name,iu2,name2)
      character*(*) name,name2
      integer k(5)
      real p(5),v(5)
      parameter(nfile=5)
      common /excomm/ jinfo(nfile),iinfo(nfile),ninfo(nfile)
     .     ,jevent(nfile),ievent(nfile),nevent(nfile),
     .     jrec(nfile),irec(nfile),nrec(nfile),iunit(nfile),
     .     istat(nfile),iacc(nfile),cross(nfile)
      integer idummy(2)
      ifile=1
      open(iu,file=name)
      read (iu,*) nv,iv,cr
      write (*,*) 'Found a file for ',nv,' events'
      write (*,*) 'of which ',iv,' are filled'
      write (*,*) 'starting to copy events...'
      call exmake(ifile,iu2,name2,nv)
      call exsetc(ifile,cr)
      do 10,i=1,iv
         call exexrd(iu)
         call exwrit(ifile)
 10   continue
      close(iu)
      call exsave(ifile)
      end

      subroutine exmake(ifile,iu,fname,ne)
      character*(*) fname
      parameter(nfile=5)
      common /excomm/ jinfo(nfile),iinfo(nfile),ninfo(nfile)
     .     ,jevent(nfile),ievent(nfile),nevent(nfile),
     .     jrec(nfile),irec(nfile),nrec(nfile),iunit(nfile),
     .     istat(nfile),iacc(nfile),cross(nfile)
      logical isther

      if (ifile.lt.1.or.ifile.gt.nfile) then
         write (*,*) 'wrong file number ',ifile,' in exmake'
         stop
      endif
      iunit(ifile)=iu
      inquire(file=fname,exist=isther)
      if (isther) then
         write (*,*) 'File ',fname,' already exists, delete first'
         stop
      endif
      open (iunit(ifile),file=fname,form='unformatted',
     .     access='direct',recl=60)
      jinfo(ifile)=0
      iinfo(ifile)=0
      ninfo(ifile)=0
      jevent(ifile)=1
      ievent(ifile)=0
      nevent(ifile)=ne
      irec(ifile)=nevent(ifile)+2
      nrec(ifile)=irec(ifile)
      iacc(ifile)=-1
      cross(ifile)=-1.0
      write (iunit(ifile),rec=1) nevent(ifile),cross(ifile),
     .     nevent(ifile),nevent(ifile),ievent(ifile),irec(ifile)
      end

      subroutine exsetc(ifile,cr)
      parameter(nfile=5)
      common /excomm/ jinfo(nfile),iinfo(nfile),ninfo(nfile)
     .     ,jevent(nfile),ievent(nfile),nevent(nfile),
     .     jrec(nfile),irec(nfile),nrec(nfile),iunit(nfile),
     .     istat(nfile),iacc(nfile),cross(nfile)
      if ((ifile.le.0).or.(ifile.gt.nfile)) then
         write (*,*) 'file number ',ifile,' out of range'
         stop
      endif
      cross(ifile)=cr
      end

      subroutine exexrd(iu)
      implicit double precision (a-h,o-z)
      common /pyjets/ n,npad,k(4000,5),p(4000,5),v(4000,5)
      read (iu,*) n
      do 10,i=1,n
         read (iu,*) (k(i,l),l=1,5),(p(i,l),l=1,5),
     .        (v(i,l),l=1,5)
 10   continue
      end

      subroutine exwrit(ifile)
      double precision p,v
      real p0(5),v0(5)
      common /pyjets/ n,npad,k(4000,5),p(4000,5),v(4000,5)
      parameter(nfile=5)
      common /excomm/ jinfo(nfile),iinfo(nfile),ninfo(nfile)
     .     ,jevent(nfile),ievent(nfile),nevent(nfile),
     .     jrec(nfile),irec(nfile),nrec(nfile),iunit(nfile),
     .     istat(nfile),iacc(nfile),cross(nfile)
      save

      if (ifile.lt.1.or.ifile.gt.nfile) then
         write (*,*) 'wrong file number ',ifile,' in exwrit'
         stop
      endif
      if (iacc(ifile).ge.0) then
         write (*,*) 'error in exwrit:'
         write (*,*) 'file number ',ifile,
     .        ' is opened for reading only'
         stop
      endif
      if (ievent(ifile).ge.nevent(ifile)) return
      ievent(ifile)=ievent(ifile)+1
      write (iunit(ifile),rec=ievent(ifile)+1) ievent(ifile),
     .     irec(ifile),n,irec(ifile),n,irec(ifile),n
      do 10,i=1,n
         do 1,j=1,5
            p0(j)=p(i,j)
            v0(j)=v(i,j)
 1       continue
         write (iunit(ifile),rec=irec(ifile)+i-1)
     .        (k(i,j),j=1,5),(p0(j),j=1,5),(v0(j),j=1,5)
 10   continue
      irec(ifile)=irec(ifile)+n
      end

      subroutine exsave(ifile)
      parameter(nfile=5)
      common /excomm/ jinfo(nfile),iinfo(nfile),ninfo(nfile)
     .     ,jevent(nfile),ievent(nfile),nevent(nfile),
     .     jrec(nfile),irec(nfile),nrec(nfile),iunit(nfile),
     .     istat(nfile),iacc(nfile),cross(nfile)

      if (ifile.lt.1.or.ifile.gt.nfile) then
         write (*,*) 'wrong file number ',ifile,' in exsave'
         stop
      endif
      if (iacc(ifile).ge.0) then
         call exclos(ifile)
         return
      endif
      write (iunit(ifile),rec=1) nevent(ifile),cross(ifile),
     .     nevent(ifile),nevent(ifile),ievent(ifile),irec(ifile)
      close (iunit(ifile))
      end

      subroutine exclos(ifile)
      parameter(nfile=5)
      common /excomm/ jinfo(nfile),iinfo(nfile),ninfo(nfile)
     .     ,jevent(nfile),ievent(nfile),nevent(nfile),
     .     jrec(nfile),irec(nfile),nrec(nfile),iunit(nfile),
     .     istat(nfile),iacc(nfile),cross(nfile)
      if (ifile.lt.1.or.ifile.gt.nfile) then
         write (*,*) 'wrong file number ',ifile,' in exclos'
         stop
      endif
      if(iacc(ifile).lt.0) then
         call exsave(ifile)
         return
      endif
      close (iunit(ifile))
      end

