      program import
      CHARACTER*(255) NAME1,NAME2
      write (*,*) 'Please enter the name of the source file'
      read (*,*) name1
      write (*,*) 'Please enter the name of the target file'
      read (*,*) name2 
      call exopen(1,10,name1)
      call exexp2(1,11,name2)
      call exclos(1)
      end

      subroutine exexp2(ifile,iu,name)
      character*(*) name
      integer k(5)
      real p(5),v(5)
      parameter(nfile=5)
      common /excomm/ jinfo(nfile),iinfo(nfile),ninfo(nfile)
     .     ,jevent(nfile),ievent(nfile),nevent(nfile),
     .     jrec(nfile),irec(nfile),nrec(nfile),iunit(nfile),
     .     istat(nfile),iacc(nfile),cross(nfile)
      integer idummy(2)
      open(iu,file=name)
      read (iunit(ifile),rec=1) nevent(ifile),cross(ifile),
     .     idummy,ievent(ifile),irec(ifile)
      write (iu,*) nevent(ifile),ievent(ifile),cross(ifile)
      do 10,i=1,ievent(ifile)
         call exread(ifile,i)
         call exexwr(iu)
 10   continue
      close(iu)
      end

      subroutine exexwr(iu)
      implicit double precision (a-h,o-z)
      common /pyjets/ n,npad,k(4000,5),p(4000,5),v(4000,5)
      write (iu,*) n
      do 10,i=1,n
         write (iu,*) (k(i,l),l=1,5),(real(p(i,l)),l=1,5),
     .        (real(v(i,l)),l=1,5)
 10   continue
      end

      subroutine exopen(ifile,iu,fname)
      character*(*) fname
      logical isther
      parameter(nfile=5)
      common /excomm/ jinfo(nfile),iinfo(nfile),ninfo(nfile)
     .     ,jevent(nfile),ievent(nfile),nevent(nfile),
     .     jrec(nfile),irec(nfile),nrec(nfile),iunit(nfile),
     .     istat(nfile),iacc(nfile),cross(nfile)
      integer idummy(2)

      if (ifile.lt.1.or.ifile.gt.nfile) then
         write (*,*) 'wrong file number ',ifile,' in exopen'
         stop
      endif
      inquire(file=fname,exist=isther)
      if (isther.neqv..true.) then
         write (*,*) 'error in exopen:'
         write (*,*) 'file ',fname,' does not exist'
         stop
      endif
      iunit(ifile)=iu
      open (iunit(ifile),file=fname,access='direct',recl=60)
      read (iunit(ifile),rec=1) nevent(ifile),cross(ifile),idummy,
     .     ievent(ifile),irec(ifile)
      iacc(ifile)=1
      end

      subroutine exread(ifile,i)
      integer i
      parameter(nfile=5)
      common /excomm/ jinfo(nfile),iinfo(nfile),ninfo(nfile)
     .     ,jevent(nfile),ievent(nfile),nevent(nfile),
     .     jrec(nfile),irec(nfile),nrec(nfile),iunit(nfile),
     .     istat(nfile),iacc(nfile),cross(nfile)
      real p0(5),v0(5)
c      common /lujets/ n,k(4000,5),p(4000,5),v(4000,5)
      double precision p,v
      common /pyjets/ n,npad,k(4000,5),p(4000,5),v(4000,5)

      if (ifile.lt.1.or.ifile.gt.nfile) then
         write (*,*) 'wrong file number ',ifile,' in exread'
         stop
      endif
      if(iacc(ifile).le.0) then
         write (*,*) 'error in exread:'
         write (*,*) 'file number ',ifile,' is not opened for'
         write (*,*) 'reading'
         stop
      endif
      if(i.gt.nevent(ifile).or.i.le.0) then
         write (*,*) 'error in exread:'
         write (*,*) 'file number ',ifile,' does not contain'
         write (*,*) 'event number ',i
         stop
      endif
      read (iunit(ifile),rec=i+1) j,ip,n
c      read(iunit(ifile),rec=ip) j
      do 10,j=1,n
c         read(iunit(ifile),rec=ip+j)
         read(iunit(ifile),rec=ip+j-1)
     .        (k(j,l),l=1,5),(p0(l),l=1,5),(v0(l),l=1,5)
         do 1,l=1,5
            p(j,l)=p0(l)
            v(j,l)=v0(l)
 1       continue
 10   continue
      end

      subroutine exclos(ifile)
      parameter(nfile=5)
      common /excomm/ jinfo(nfile),iinfo(nfile),ninfo(nfile)
     .     ,jevent(nfile),ievent(nfile),nevent(nfile),
     .     jrec(nfile),irec(nfile),nrec(nfile),iunit(nfile),
     .     istat(nfile),iacc(nfile),cross(nfile)
      if (ifile.lt.1.or.ifile.gt.nfile) then
         write (*,*) 'wrong file number ',ifile,' in exclos'
         stop
      endif
      if(iacc(ifile).lt.0) then
         call exsave(ifile)
         return
      endif
      close (iunit(ifile))
      end

      subroutine exsave(ifile)
      parameter(nfile=5)
      common /excomm/ jinfo(nfile),iinfo(nfile),ninfo(nfile)
     .     ,jevent(nfile),ievent(nfile),nevent(nfile),
     .     jrec(nfile),irec(nfile),nrec(nfile),iunit(nfile),
     .     istat(nfile),iacc(nfile),cross(nfile)

      if (ifile.lt.1.or.ifile.gt.nfile) then
         write (*,*) 'wrong file number ',ifile,' in exsave'
         stop
      endif
      if (iacc(ifile).ge.0) then
         call exclos(ifile)
         return
      endif
      write (iunit(ifile),rec=1) nevent(ifile),cross(ifile),
     .     nevent(ifile),nevent(ifile),ievent(ifile),irec(ifile)
      close (iunit(ifile))
      end

